require 'net-telnet'

class RubyMas
  def initialize(hash)
    @connection = hash
  end

  def test_connect
    telnet.cmd(@connection[:user]) {|c| print c}
    telnet.cmd(@connection[:password]) {|c| print c}
    telnet.close
  end

  def workorder_report
    connect
    run_report
    telnet.cmd("WOH_DUMP")
    finish
  end

  def inventory_report
    connect
    run_report
    telnet.cmd("HP_DUMP3")
    telnet.cmd("p")
    telnet.cmd("fil")
    telnet.cmd("/usr/common")
    telnet.cmd("invdump.csv")
    telnet.cmd("3")
    telnet.cmd("")
    telnet.cmd("Y")
    telnet.cmd("")
    telnet.cmd("")
    telnet.cmd("")
    finish
  end

  private
  def telnet
    @telnet ||= Net::Telnet::new("Host"    => @connection[:host],
                                 "Timeout" => 5,
                                 "Prompt"  => //,
                                 "Waittime" => 1
                                 )
  end
  def connect
    telnet.login(@connection[:user], @connection[:password])
    telnet.cmd("")
    telnet.cmd(@connection[:mas_user])
    telnet.cmd(@connection[:mas_pass])
    telnet.cmd("")
    telnet.cmd("")
  end
  def run_report
    telnet.cmd("7")
    telnet.cmd("2")
  end
  def finish
    telnet.cmd("")
    telnet.cmd("*END")
  end

  def quick_sleep
    sleep(1.0/24.0)
  end
end